/*
 * EventoReserva.java
 *
 * Created on 8 de mayo de 2007, 16:25
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package contweb.mvc.event;

import javax.servlet.*;
import javax.servlet.http.*;
import contweb.mvc.*; 
import contweb.mvc.init.*;
import contweb.mvc.modelo.*;

public class EventoReserva implements Evento {
    public static final String NOMBRE = "evento.reserva"; //Debe coincidir con DD
    public static final String NOM_CANTIDAD = "cantidad";
    private static final String JSP_DESTINO = "/jsp/ReservaLibros.jsp";
    private static final String JSP_ERROR = "/jsp/ErrorReservar.jsp";
  
    public EventoReserva() {} //Constructor vaco para instanciacin dinmica.

    //Mtodo sincronizado para evitar problemas de concurrencia al comprobar el stock
    public synchronized String procesar(ServletContext ctx, HttpServletRequest req) {
        int cantidad = Integer.parseInt(req.getParameter(NOM_CANTIDAD));
        Almacen almacen = (Almacen)ctx.getAttribute(InicializadorLibros.NOM_ALMACEN);
        Libro libro = almacen.getLibro(req.getParameter(EventoConsulta.NOM_LIBRO));
        if (cantidad <= libro.getStock()) {  //Comprobacin del stock 
            libro.reducirStock(cantidad);
            return  JSP_DESTINO;
        } else {
            return  JSP_ERROR;
        }
    }
}
