/*
 * InicializadorLibros.java
 *
 * Created on 8 de mayo de 2007, 13:07
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package contweb.mvc.init;

import javax.servlet.*; 
import contweb.mvc.*; 
import contweb.mvc.modelo.*;

public class InicializadorLibros implements Inicializador  {
    public static final String NOM_ALMACEN = "almacen";
    private static final String ARCHIVO = "archivo";         //Debe coincidir con el DD.
    private static final String SEPARADOR = "separador"; //Debe coincidir con el DD.
    public InicializadorLibros() {} //Constructor vaco para instanciacin dinmica.
    public void init(ServletConfig cfg) throws ServletException {
        ServletContext ctx = cfg.getServletContext();
        String fichero = ctx.getInitParameter(ARCHIVO);
        String separador = ctx.getInitParameter(SEPARADOR);
        try {
            if (fichero == null || fichero.trim().equals("") || separador == null || separador.trim().equals("")) {
                throw new IllegalArgumentException("Datos de inicializacin insuficientes");
            } else {
                Almacen almacen = new Almacen(new java.io.File(ctx.getRealPath("/") + fichero), separador.charAt(0));
                ctx.setAttribute(NOM_ALMACEN, almacen);
            }
        } catch (Exception e) {
            throw new ServletException(e.getMessage());
        }
    }
}
